

public class ThermImplC2 implements ExampleC.ThermometerOperations
{
    ExampleC.Thermometer theRealThermometer;
    
    public ThermImplC2 (ExampleC.Thermometer tm)
    {
	theRealThermometer = tm;
    }

    public String location()
    {
	return theRealThermometer.location();
    }

    public void getTemperature(ExampleB.TemperatureHolder th)
    {
	theRealThermometer.getTemperature(th);
    }

    private double convertToK (ExampleB.Temperature t)
	throws ExampleC.CannotConvertUnit
    {
	double temp;
	
	if (t.unit.equals(ExampleB.TempUnit.KELVIN))
        {
	    temp = t.value; 
	} 
	else if (t.unit.equals(ExampleB.TempUnit.CELSIUS))
	{
	    temp = t.value + 273.15;
	}
        else if (t.unit.equals(ExampleB.TempUnit.FAHRENHEIT))
        {
	    temp = (t.value - 32.0) * 5.0 / 9.0 + 273.15;
	}
	else
	{
	    throw new ExampleC.CannotConvertUnit();
	}
	    
	return temp;
    }

    
    public double getTemperatureInUnit (ExampleB.TempUnit unit)
	throws ExampleC.CannotConvertUnit
    {
	double temp;
	
	try
	{
	    temp = theRealThermometer.getTemperatureInUnit(unit);
	}
	catch (ExampleC.CannotConvertUnit e)
	{
	    ExampleB.TemperatureHolder th = new ExampleB.TemperatureHolder();
	    
	    theRealThermometer.getTemperature(th);

	    ExampleB.Temperature t = th.value;

	    if (unit.equals(ExampleB.TempUnit.KELVIN))
	    {
		temp = convertToK(t); 
	    } 
	    else if (unit.equals(ExampleB.TempUnit.CELSIUS))
	    {
		temp = convertToK(t) - 273.15;
	    }
	    else if (unit.equals(ExampleB.TempUnit.FAHRENHEIT))
	    {
		temp = (convertToK(t) - 273.15) * 9.0 / 5.0 + 32.0;
	    }
	    else
	    {
		throw new ExampleC.CannotConvertUnit();
	    }
	}
	return temp;
    }
}

